﻿
## AutomationML Editor Release Notes

### [Version 6.2.4](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.2.4) 

#### Bug-Fixes
- Fixed an issue where exchange of unverified libraries raised an exception.
- Fixed an issue where derivation of an attribute type in the find online dialog failed to get the correct CaexPath.
- Fixed an issue, where home url in server configuration was not updated when the user name is modified.

#### Changes
- Status Message in the FindOnline Dialog is made more noticeable
- Folder location in server configuration are always editable
- FilePath of current selected server profile is shown in status line of server configuration window.

### [Version 6.2.3](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.2.3) 

#### New Features
- The 'Find class online dialog' contains a new option to define an inheritance relation between the selected class and the class found.
- The 'Find class online dialog' contains a new option to define a semantic reference when the dialog is called from a selected attribute type.
- The 'Add Reference ... dialog' contains a new option to create new versions for all libraries contained in the referenced document.
- A Semantic reference to an AutomationML attribute provides a new button/ method to lookup the attribute definition.
- It is now possible to create versions for classes and attribute types without a drag/drop operation if the containing library is already modeled as a new library version.

#### Bug-Fixes
- Fixed an issue where online search of existing classes throw an exception.
- Fixed an issue where excluded instance hierarchies are still be included in the outsource dialog.
- ExternalReference Path editor allows selection of files from local storage.
- Fixed a bug in the outsourcing dialog
- Fixed a bug in publishing dialog
- Fixed a bug in undo/redo methods when a transaction includes multiple documents
- The error that the help pages were no longer offered has been fixed.
- ExternalReferences which are no more used after outsource was successfull will be deleted.
- It is no more possible to add references to multiple versions of the same library to the same document.

#### Changes
- Attribute Types in published libraries must have a unique ID assigned
- Library dependency view needs to be activated by clicking a button to show the dependency graph.
- ExternalReferences used for version relations are distinguished from ExternalReferences used to access external model objects.
- ExternalReferences which are no more used after outsource was successfull will be deleted.


### [Version 6.2.2](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.2.2) 

#### New Features
- A repository of all published classes and attribute types is available on the AutomationML file server. Published classes and attribute types can be searched for in the editor using a similarity search. If the search is successful, the required external reference is generated if required. 

#### Changes
- The prefix 'AutomationML' is treated as a reserved name for libraries that are published on the AutomationML file server.
- When publishing libraries, the repository of classes and attribute types is updated.

#### Bug-Fixes
- Fixed some issues regarding publishing of new library versions.
- Fixed an issue where publishing a library without signing threw an exception.

### [Version 6.2.1](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.2.1) 

With version 6.2, the AutomationML Editor offers more **support for the management and creation of AutomationML class libraries** according to [Conventions for the modelling of AutomationML libraries](https://www.automationml.org/wp-content/uploads/2023/11/Conventions-for-modelling-AutomationML-libraries-V1.0.0-external.pdf) in addition to continuous bug fixing.  The new functions are activated by default, but they can be deactivated via the options dialog.  

The most important improvement in version 6.2 is the distribution of AutomationML libraries via a publicly accessible file server and the integration of the libraries via external references. The editor contains a preconfigured access to the **AutomationML NextCloud** as a file server. However, it is also possible to use a company-owned or privately used file server as long as it is accessible via the WebDAV/Https network protocol. All configured servers can also be used in parallel.

As the AutomationML NextCloud server could be replaced in the future, the URLs of the integrated external references for accessing the libraries would have to be changed in this case. However, when a new server is introduced, the editor will provide a feature, to redirect and update the external addresses automatically.

You can find detailed instructions on how to use the new features in the wiki on the following topics:
- [Using external Sources](https://github.com/AutomationML/AutomationMLEditor/wiki/UsingExternals)

- [External Source Windows](
  https://github.com/AutomationML/AutomationMLEditor/wiki/Layout#External-source-windows)

- [Preview Windows](https://github.com/AutomationML/AutomationMLEditor/wiki/Layout#Preview-windows)

- [Publishing](https://github.com/AutomationML/AutomationMLEditor/wiki/Publish)

Version 6.2.1 is published for the [.NET 8 Desktop Runtime](https://dotnet.microsoft.com/en-us/download/dotnet/8.0).  

#### Options to activate library management
- Select the **Access External AutomationML Files** in the options dialog or from the editors main tool bar to get access to external AutomationML files from the AutomationML file server (currently the NextCloud; Internet access is required). Please note that by enabling this feature, the former provided import function from the AutomationML website will be disabled.
- Select the **Save Externals** in the options dialog to enable the local storage of referenced external libraries when saving the document. This means that all referenced external libraries, as well as their dependencies are stored to the documents relative folder '**_AMLExternalLibraries**' and are available offline for the current document.
- Edit or configure access profiles for file servers from the options dialog.

#### New functions for library management 
- The *File menu* contains the new **Add Reference** function. This allows the content of an AutomationML file from an external source, either from the AutomationML server or a company's own source, to be integrated into an existing document as an ExternalReference. All libraries from the external AutomationML file are displayed in separate windows ('External Views'). This function is only available if the **Access External AutomationML Files** option is selected.
- The *File menu* contains a new method **Outsource Libraries**. This function can be used to outsource the libraries contained directly in the document. Libraries that are published on the AutomationML library server are integrated as external sources, other libraries are outsourced to locally saved documents.
- The *File menu* contains the new **Publish** function. This function displays a dialog for publishing the currently edited AutomationML document to the activated library server. In order for a document to be published, the libraries it contains must fulfill the published conventions. When a library document is published to the AutomationML file server, all libraries are automatically signed. For user defined libraries, published to different target locations, the signing is optional.
- When library modelling conventions are reviewed the result is visualized. Specific **repair dialogs** are offered to repair failures to comply with mandatory conventions. 
- The *Open menu* provides the new **External Collections** function to load AutomationML defined library collections from the AutomationML file server or any other configured server. A collection contains preselected external references supporting specific modeling aspects. This function is only available if the **Access External AutomationML Files** option is selected.
- The *Open menu* provides the new **External Examples** function to load AutomationML defined examples from the AutomationML file server or any other configured server. Example models can contain class libraries which are not published and may contain InstanceHierarchies. AutomationML published class libraries are included using external references. This function is only available if the **Access External AutomationML Files** option is selected.
- The *View menu* provides the new **View Externals** function to open external referenced files and display the contained libraries in extra windows. 
- A new dialog has been added to browse the AutomationML file server to select libraries, models or example files. It is possible to enter filter criteria and to preview selected files. The dialog is viewed, when one of the mentioned referencing functions is called.
- A new dialog has been added to add and edit **access profiles for a file server** to provide libraries, models or example files. If write access rights are defined, a server can also used to publish documents.
- A **library dependency graph** is shown as a new relation window. Library dependencies are defined by versioning relations between libraries and class to class relations. 
- All external referenced files and their dependencies are automatically saved to a local folder, named **'_AMLExternalLibraries'** when a document is saved. The locally saved libraries enable the usage of the contained classed when the editor is used in offline mode.  This behavior is activated if the **Save Externals** option is selected.

#### New Features
- Support to dragg libraries and to paste them into the library container is added.
- "Create Version" is added as a new paste option for dragged libraries. Library versions can be marked as extensions.
- "Create Version" - dialog supports to edit a version number.
- Version information is shown behind the library name in tree views.
- Revision links are updated with alias references if the related version is external.
- Problem report dialog contains a new button to open the folder, containing the error log.
- New method to naviagte to all referenced role classes from systemUnit classes and InternalElements

#### Changes
- The function to create new documents initialized with AutomationML standard libraries has been removed. Standard libraries can only be used by referencing the external sources.
- The function to import AutomationML files from the AutomationML website has been removed. If the **Access External AutomationML Files** option is not selected, the import from AutomationML is still available.
- The menu item **Tools** has been renamed **Extras**.
- The menu item **Settings** has been removed. Settings can now be made in a new dialog, accessible under **Extras->Options...**. Options are grouped in categories.
- Backup file restoration dialog window can now be closed without restoring the file. Selected files are only restored, when the OK button is pressed.
- The naming for backup files has been changed. The current file name is included.
- Document version headers are not inserted into a document when no document versions are defined.
- AutomationML editor does not automatically adds a *SourceDocumentInformation* object to a modified document if a *SourceDocumentInformation* already exists.
- Split always creates an external reference into the remaining document, also when no classes of the splitted libraries are referenced.
- External reference path are created as relative paths when the location of the external document is relative to the edited document.
- Allowing references to external sources from documents, contained in an AutomationML container.
- Facet-Names of sibling facet-elements are checked to be unique.

#### Bug-Fixes
- Fixed an issue where opening settings threw an exception.
- Fixed an issue where the expansion state of properties was not maintained when the view changed.
- In the file-name attribute of a CAEX-Document no longer the complete file path is stored but only the filename. 
- Fixed an issue where the name of the backup file was shown as the file-name attribute instead of the document filename.
- Fixed an issue where documents in the document version collection of an AML File were deleted.
- Fixed an issue where expanded collection in views could not be closed.

### [Version 6.1.8](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.1.8) 
#### Issues Addressed in this Release

- Fixed a problem that could cause ambiguous CAEX paths for attribute elements defined in classes. See the reported [issue](https://github.com/AutomationML/AMLEngine2.1/issues/22#issuecomment-1476409454).

### [Version 6.1.7](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.1.7) 
#### Issues Addressed in this Release

- Fixed a problem that causes a crash when an internal element with an internal link under a system unit class is deleted.

### [Version 6.1.6](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.1.6) 
#### Issues Addressed in this Release

#### Bug-Fixes

- There were <u>two different implementations</u> of the `DocumentVersion` elements in the AMLEngine, these versions are unified with version 3.1 of the engine. The editor uses the unified version now. `DocumentVersion` Information in existing AML-Documents which use the no longer supported version are automatically changed. Detailed Explanations about the differences can be found in the [AMLEngine project repository](https://github.com/AutomationML/AMLEngine2.1/blob/master/Documentation/DocumentVersionsInAML.md).
- Merging of `ExternalReferences` into the document is fixed. This feature was disabled in last versions.
- Highlight of selected elements in inactive views has been removed.
- Visualization of InternalLink Lines could raise an exception or even an application crash.
- Alias references were not always updated correctly when the Alias of the ExternalReference changes.
- Changed style of validation notifications in attribute- and property editors.
- Fixed some styling issues related to the visualization of informational notes when the dark theme is used
- Fixed an issue regarding loading PlugIns which have dependencies to other nuget packages. 

#### New Features

- A new Split Dialog exists which allows to edit the `Alias Name` for the created `ExternalReference` element.
- Adding a new child class will automatically create an inheritance relation between the parent and the child class now. This behavior can be switched off in the global settings. It is initially activated.
- Loading very large files (> 500 MB) can cause large loading and running times. The editor checks the current size before loading the file and allows to cancel the loading process. 
- Editing Alias names and Path for ExternalReference elements im AMLFile view supports validation.
- Path Name Editor in ExternalReference Editor in AMLFile view offers a File Dialog to define the path.


### [Version 6.1.5](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.1.5) 
#### Issues Addressed in this Release

- The keyboard navigation with the arrow keys in the tree view is functional again.
- The buttons to activate the special edit operations in the side views were not visible in some themes. Visibility is now restored for all themes.

### [Version 6.1.4](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.1.4) 
#### Issues Addressed in this Release

- The configuration of the context menu is corrected when the mouse cursor is positioned outside the boundaries of the selected object.
- If the *Create InternalElement* option is selected when pasting a role class into a SystemUnitClass, then the options to copy the attributes and interfaces to the InternalElement are now also displayed.
- Fixed an issue when a new external document was referenced via the *RefUri Editor* the editor crashed if the edited AutomationML document was an element of an open AML container.

### [Version 6.1.3](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.1.3) 
#### Issues Addressed in this Release

- Fixed that the application stopped responding when the InternalLink interface class selection button was pressed.
- Fixed that in the view for listing all InternalLinks of the whole document there was no reaction if no object was selected.
- Fixed a problem with entering the password in the login dialog for AutomationML members.

### [Version 6.1.2](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.1.2) 
#### Issues Addressed in this Release

- Fixed problems related to the visualization of InternalLink lines
- Fixed a problem that causes a crash when an AutomationML object was created from a class 
- Fixed a problem related to the + button to add elements when 2 clicks are needed to create the first element 
- InternalLink elements can now no longer be added via the context menu of a SystemUnitClass or InternalElement, but via the context menu of an ExternalInterface element. A dialog is opened for configuring the InternalLink.  This is an alternative to the graphical creation of an InternalLink element [(see this video on youtube](https://youtu.be/watch?v=i85Fxg8VYz0)).
- Added support for Aml.Editor.API version 2.0.1

### [Version 6.1.1](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.1.1) 
#### Issues Addressed in this Release

- Internal link connection lines could not be displayed for large distances between the interfaces,
since the position of the start and end points no longer exist for the calculation of the line coordinates.
Now the line coordinates are approximated and all connecting lines are always represented. The position of the lines
can shift however when scrolling the window contents.
- Cardinality violations for InternalLinks are now checked in the document
validation.
- If the cardinality of an ExternalInterface is changed, the display is updated now. 

### [Version 6.1.0](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.1.0) 
#### Issues Addressed in this Release

- Loading documents could take a very long time if the document references libraries that are not included in the document itself and have a lot of references on it.  The loading time has now been improved.
- A new offline mode (without internet connection) can be configured in the settings. In offline mode, libraries and models cannot be loaded from the AutomationML website. Some services that require access to the AutomationML cloud are also not available.
This mode has been added to enable the usage of the AutomationML editor for people and organizations who are not allowed to use software, which silently use internet connections. The offline mode is **not set** by default.
- The .NET 5.0 runtime has reached end of support on May 10, 2022. Microsoft will no longer provide servicing updates, including security fixes or technical support, for .NET 5.0. 
Therefore, new versions of the editor including this version are offered for the .NET 6.0 runtime only due to security considerations.
- Selecting an object with attributes automatically selects the first attribute in the Attributes view. This feature has been disabled now because this could cause problems when editing the objects header attributes.
- Saving an aml document to a container could raise an exception in some situations. This is fixed.
- Foreground color of description area changed to a white brush when color theme is set to a dark mode.
- Adding a show clear text button to password box in AML Login

### [Version 6.0.5](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.0.5) 
#### Issues Addressed in this Release

- A new feature to support name validation has been added to the document validation service.
- A problem related to systems with English language locale is fixed.
- A .NET 6.0 version is available on request. The publicly distributed version is still based on .NET 5.0.


### [Version 6.0.4](https://github.com/AutomationML/AutomationMLEditor/releases/tag/v6.0.4) 
#### Issues Addressed in this Release

- The License Dialog provides a new option for the distribution of license files.
- InternalLink Line drawings respond to UI Scaling, this can avoid some visualization problems showing link lines.
- An *Open Backupfolder* - button has been added to the backup file selection dialog.
- Menu items in the context menu of tree nodes are regrouped and rearranged. 
- The Visual layout of *Attribute Tables* has been improved.
- The performance of *attribute view switching* has been improved.
- Property Description Area allows scrolling of content.
- All ***Header*** definitions of all CAEX Objects can now be edited
	- ***Constraint-Header*** (editor is started from *constraint context menu*)
	- ***RefSemantic-Header*** (editor is started from *refsemantic context menu)*
	- ***Revision-Header*** (editor is started from *revision context menu*)
	- ***ExternalReference-Header*** (editor is started from *externalreference context menu*)
	- ***CAEXFile-Header*** (editor is active when no other object is selected)
	- ***InternalLink-Header*** (editor is active, when a link line is selected)
- A **new Editor Update feature** and installation procedure is implemented. Future updates will no longer be published as msi-installer files. This version of the editor comes with a new embedded update feature. The next version update will be published as a self contained zip file and does not require an installer.  This version is the last version, published with an installer. You will be notified with a new update dialog, when an update is available. There are options to skip a version or to postpone the update to a later time.

### Version 6.0.3
#### Issues Addressed in this Release

- Plugin developers can now use the [Aml.Editor.API package](https://www.nuget.org/packages/Aml.Editor.API/). This allows plugins to directly call methods of the editor even outside the classes instantiated by the editor through Composition. 
- Fixed some presentation problems related to UI command icons

### Version 6.0.2
#### Issues Addressed in this Release

- Adaption to the new [Plugin Contract](https://www.nuget.org/packages/Aml.Editor.Plugin.Contract/).
- Capture Dialog will now copy the captured image to the clipboard while the dialogue is still open


### Version 6.0
#### Issues Addressed in this Release

- This version requires a license to be able to use all features. Licenses for AutomationML members are provided by 
the AutomationML association. The Editor displays a dialogue for including a valid license when the menu item *Information.Registration/Licensing* is selected. 
License files are saved in the *%AppData%/AutomationMLEditor/License* folder. For a direct download of a license file, 
provided for AutomationML members, a valid account for the AutomationML cloud is needed.
- PlugIn loading mechanism changed to use the new Nuget v3 interface. PlugIns need to be updated to be compatible with this version..
- The editor will be installed with no additional PlugIns. PlugIns have to be installed using the PlugIn Manager.
- In AutomationML 2.1 documents the usage of the Standard "CARDIANALITY"-Attribute Type is supported. The modelled multiplicity of
Internal Links can be visualized and will be checked.
- In Mirror Elements the complete object tree of the referenced master element can be visualized and edited.
- AutomationML Documents, received from official AutomationML resources contain signed libraries. The validity of a signature is
marked at the library tree node. Signed libraries are not editable unless the protection mode is disabled.
- AutomationML libraries which are marked with an invalid signature can be exchanged with signed and valid versions.
- The Insertion of Mirror Elements is restricted to provide reference recursions and reference cycles.
- New Paste Action Option 'Append Derivation' added for classes
- New Paste Action Option 'Replace with new instance' added for InternalElement Targets and SystemUnitClass Source 
- New Paste Action Option 'Assign Reference' added for Instance Targets and Class Source (InternalElement, SystemUnitClass), 
(ExternalInterface, InterfaceClass) and (Attribute, AttributeType).
- New Paste Action Option 'Update Instance' added for Instance Targets and Class Source (InternalElement, SystemUnitClass), 
(ExternalInterface, InterfaceClass), (RoleRequirement, RoleClass) and (Attribute, AttributeType).
- Update Instance method added to context menu of instances and classes. 
- Capture window has new arranged capture buttons.
- ExternalDataReferences to Images using the correct MimeType are visualized using the linked external image when the linked image exists.
- The UI has been modernized and supports a new dark theme. 
- Highlight of active Selections are only visible in currently active views.
- New AutoSave mode option (set by default) added. When set, a backup of the current open document is automatically saved every minute.
- New Document Method provides options to create empty documents or documents containing libraries.
- New Document Method added as toolbar button.
- Inherited Attributes are visualized as read-only items in tabular edit mode

- **The Version 6.0 needs the .NET 5.0 runtime.**

#### Bug Fixes in this release
- Fixed an issue in the management of path references which could raise an unhandled exception. This could happen, for example, if existing libraries referencing other classes 
were overwritten during import (old version deleted and new version inserted).
- Paste Dialog Window opens correctly at the current mouse position on multiple screen configurations.
- Selection Feedback for InternalLink lines are updated correctly if a connection end is moved.
- Special Editor windows as Facet Editor and Role Instantiation window display a scroll bar when the items list doesn't fit to the screen.
- Fixed some issues related to external references to container parts and reassignment of URI addresses to container parts.

#### Note to PlugIn developers
- With the introduction of version 6.0, only plugIns that support at least .NET 5.0 are supported. 



### Version 5.6.11

### Issues Addressed in this Service Release

- Runtime version changed to .NET Framework 4.8
- Update to last version of Aml.Engine


### Version 5.6.10

#### Issues Addressed in this Release

- New method **Copy CAEX object ID** in context menu of tree nodes allows to copy the CAEX object ID.
- Move and Copy paste actions are defined now also for Role references (SupportedRoleClass and RoleRequirements).
- New feature in reference navigation dialogue allows to navigate forward and backward.
- New feature in paste dialogue allows to apply the paste action without closing the dialogue and to proceed with another selected target.
- New search option **Attribute value** in tree search allows to search for elements with a specific attribute value.
- Additional button in tree search control allows to reduce or enlarge the tree to display the search result.
- New navigation buttons are shown in a new pop-up window at the bottom of the search dialogue when a text is entered in the search field, F3 and shift+F3 are supported.
- The search range is defined by the selected element in a tree view, the current range is labelled in the pop up window.
- New method **Goto referenced CAEX object** added to attribute context menu if the attribute datatype is defined as **xs:IDREF** and the value is a valid CAEX object ID.


### Version 5.6.9

#### Issues Addressed in this Release

- Fixed an issue in the edit group dialogue which throws an exception when an InternalElement was added to the group
- Fixed a bug when Editor crashes on start-up if configure file setting ResolveExternalReferences is set to True.


### Version 5.6.8

#### Issues Addressed in this Release

- Fallback method added when download of WEB Resources failed.


### Version 5.6.7

#### Issues Addressed in this Release

- Adaption to new AutomationML corporate design
- Enable reload of WEB Resources when Web connection fails [(Related Information)](https://github.com/AutomationML/AutomationMLEditor/wiki/WebResources/).

### Version 5.6.6

#### Issues Addressed in this Release

- Allowing to add "Sub Attributes" of AttributeTypes using the '+' button.
- Allowing to edit "Sub Attributes" of AttributeTypes when they are selected in the library tree view.

### Version 5.6.5

#### Issues Addressed in this Release

- Library import from AutomationML provides new items
- The included AutomationML Standard libraries Edition 2.1 
  have been exchanged for the versions offered on the AutomationML site. Please be aware, that the AutomationML Standard AttributeTypeLib has been updated. 
  A minor deviation from the standard attribute type library published in the IEC 62714 standard is now fixed.
- Layout Improvements in Start Page
- Layout Improvements in Import Libraries Dialog
- Collapse All for expanded tree views added

### Version 5.6.4

#### Issues Addressed in this Release

- Fixed an issue where navigation to a base class raised an exception when the class reference could not be resolved to an existing class.
- A new option **Resolve External References** allows references to classes in external documents to be taken into account when creating instances and visualizing inheritance.
- Fixed an issue where visualising inherited attributes does not show any items.
- Reversion of version 5.6.3 due to an update error where menu entries are disabled.

### Version 5.6.2

#### Issues Addressed in this Release
- Fixed an issue where loading an AML file would fail with a double click from the explorer window.
- A new option 'Settings-Resolve External References' allows references to classes in external documents to be taken into account when creating instances and visualizing inheritance relations.

### Version 5.6.1

#### Changes

When an AutomationML container is opened and modified, the Editor doesn't operate on the original source but on a
backup copy of the container file. The original container file will only be modified if the edited content is saved.

### Version 5.6.0

#### Bug Fixes

- Fixed an exception in AML Editor 5.5.3 when exchanging root document in AMLContainer.
- Fixed an issue, when trying to add an AML file as “additional Content”. One could select
in the next dialogue that this is a “library”. But then the tool refuses to add the file with some strange error message.
- It is possible now to edit the URL of a content part (like /sub/content.aml) to place content in a subfolder of a container.

#### Changes

- The folder browser dialogue has been exchanged.


#### Updates
- AutomationML editor uses **Aml.Engine v1.6.2**


### Version 5.5.6

#### Changes

1. During document validation, Object IDs that are not implemented as GUIDs are no longer reported as incorrect formats. The implementation of IDs as GUIDs according to RFC4122 
is a recommendation and may be handled differently by other tools. If the GUID format is not used it may be difficult to 
distinguish a name reference from an ID reference in certain situations.

2. Minor Changes in the Model and News explorer should improve the look and feel.

### Version 5.5.5

#### Changes

1. The editor now offers the possibility to download AutomationML libraries and
models directly from the new AutomationML download page.

2. In addition, the model explorer has been adapted and the AutomationML models
and examples linked via the AML book have been integrated. 
For this purpose, the referencing scheme for the model page and the news
page has been adapted.

3. The included AutomationML Standard libraries Edition 2.1 
have been exchanged for the versions offered on the AutomationML site.



### Version 5.5.4

#### Changes

The AutomationML Association renews its web representation. 
This also makes some resources used by the editor temporarily
unavailable. Before a new permanent solution is implemented,
the editor uses a resource library provided on GitHub. This is
used temporarily to install program updates and publish news. 
For future use of modelling resources, it is required that 
you update your AutomationML Editor version by **July 12 at the latest.**

### Version 5.5.3

#### Bug Fixes

1. Attribute Editor switched to disable mode for attribute mirrors if a wrongly referenced attribute type was identified as an attribute master.
2. Fixed a bug creating SystemUnitClasses from InternalElements, when the InternalElement has InternalLinks.

### Version 5.5.2

#### Bug Fixes

1. Editing of AttributTypeLibraries is enabled again.
2. Vertical Scrollbars in library views are only visible if needed. This affects the capture dialogue, too.
3. The default name for all new AML files is "newfile.aml"
4. Saving a new AML file as a container will change the name of the new AML file to the name of the container.


### Version 5.5.1

#### Bug Fixes

AMLFile properties could not be edited if no object was selected before.

#### Added Feature

ID and IDRef XS-Data types are editable as normalized strings when used as
AttributeDataTypes in Attribute definitions.

### Version 5.5.0

#### Changes

In this version of the editor, the appearance of the editor has been 
changed a little. A slightly improved icon library is used to 
represent the AutomationML objects, in which the icons have been
made slightly more readable and the display efficiency has been optimized. 
This library is publicly available via the AutomationML website.

Attributes are now also displayed in the tree view of the attribute type library. 
This simplifies the construction of an attribute type library by making it easier 
to copy attributes back and forth between attribute types. 

#### Notes to plug-in developers
This Version supports a new Plug-in Interface *INotifyAMLDocumentSaved*. Plug-ins, implementing this
interface get a notification when an AMLFile has been saved by the AutomationML Editor.
The Plug-in contract has to be updated to version 2.4.0 to use this interface.

### Version 5.4.10
#### Fixes
1. Since version 5.4.9 no attributes of ExternalInterface objects can be edited. This bug is fixed.Since version 5.4.9 no attributes of ExternalInterface objects can be edited. This bug is fixed.


### Version 5.4.9
#### Fixes
1. The display of InternalLink lines was incorrect in certain situations and has been corrected.
2. InternalElement nodes were displayed with an expansion indicator in the tree view if a role 
was assigned to the element, even if the display of roles in the tree view was hidden. 
In certain situations this could lead to the editor being unusable when scrolling to the end of the tree.

### Version 5.4.8
#### Fixes

1. Correction of editor restrictions for mirror objects and inherited objects, if they are not yet overridden. 
The reported fix from version 5.4.7 for this issue was not complete.
2. Changed the menu entry "delete" to "undo override" for removing an override.
3. Changed the menu entry "hide" to "exclude" for deleting an inherited item.
4. In the relations view, the instances of derived classes are now also displayed when the base class is selected.
5. The relation view is no longer switched automatically when a relation listed in the view is selected.
6. When creating SystemUnit class instances in CAEX 2.15 documents, an exception was thrown if the class did not have a role reference.

### Version 5.4.7
#### Fixes

1. Mirror icons were not visible since version 5.4.5. 
2. In some situations it was possible to edit read only objects, such as mirror objects. This is no longer possible.
3. When copying complete class libraries or even class trees including subclasses, the inheritance relationships between the classes within the copy were not updated. This bug has been fixed.


#### Added Features

1. The Names of referenced Master items are visualized in the tree view for
mirrors if the display of references is activated.
2. InternalLink lines can now also be opened and closed using the navigation keys to move through a tree view.
3. The Keyboard Keys ctrl+/- can now be used to Zoom In and Zoom Out.
4. The Keyboard Keys ctrl up and ctrl down can be used to move items in a tree up or down.
5. URIs of container parts can be modified, even if the part has already been created.
This also applies to the URIs of root parts. So it is now possible to change file names of AutomationML files, even if the file is part of an AMLContainer. The 
feature to edit file names was added in version 5.4.5. but throws an error, if the file
is a container part.

2. The CAEX standard allows to override inherited elements. This applies to 
	attributes and ExternalInterfaces as well as to InternalElements. 
	The overriding of inherited InternalElements was not possible until now. 
	This functionality has been added. In this version, overriding of entire 
	InternalElement trees is supported. The selective overriding of single
	branches will be possible in a future version.

	To override, the inherited elements can be displayed in a tree using
	the menu item "Show Inherited elements". The displayed elements can then be overridden
	(menu item "override") or excluded from the inheritance tree (menu item "hide"). 
	Inheritance is realized by name equality. If the name of an overridden
	element is changed, then the inheritance relation doesn't exist any more. 
	If an overridden element is deleted, the original inheritance tree is rebuild.
	Inherited Elements which are Mirror- or Master objects can not be overridden.

	**You are kindly requested to test this feature and report missing functionality, interactions that should be changed, incorrect behaviour, or other problems related to this feature.**

### Version 5.4.6
#### Fixes
1. If the mouse pointer was positioned on a node icon, the element could not be dragged while holding down the mouse button.
2. Floating Panes are now also scaled if the UI scale factor changes. PlugIns can implement the new plug-in interface *ISupportsUIZoom* to get notified when the scale factor changes.
3. Expanded views like collections in property editors were sometimes closed by the system during editing. This bug is fixed.
4. Fixed a problem with the AML container when multiple root documents are added.

### Version 5.4.5
#### Fixes
1. Fixed a problem in the editor dialogue for ExternalData where the input of an absolute or relative file address (file-URI) was not assigned to the attribute value.
2. The File name of the AMLDocument is now editable in the AMLFile View
3. Facet Attribute references in a CAEX 3.0 document are not marked as invalid when the referenced parent attribute exists.
4. Fixed a problem when a Message Box containing too much lines exceeds the available screen space. 
5. If the AutomationML editor writes new changed source document information the tool version gets updated to.

#### Added Feature
1. The locations for the configuration files, used to create the model and news pages can be changed by the user. This allows to debug
new page content before they are published and uploaded to the AutomationML repository.
2. New Models category AMLBook added. Content can be published by authors.

#### Changes
1. Container parts with a relationship type of any content are defined with an explicit MIME Type, derived from the file extension.
2. Download and Edit of AutomationML models from the models page is supported with a changed UI and adapted buttons.
### Version 5.4.4
#### Fixes
Fixed a problem in the Paste dialogue for Role Classes that caused a wrongly created instance when the copy all check box was selected.

### Version 5.4.3
#### Fixes
Fixed a problem in the ImportFrom dialogue box that caused the order of the displayed libraries to change after a selection.

### Version 5.4.2
#### Fixes
Fixed a problem in the ImportFrom dialogue box when a library needs a schema transformation before the import check box gets activated.

### Version 5.4.1
#### Added Feature
The Editor allows the editing of Attribute Data Types "hexBinary" and "base64Binary". 
It is possible to enter binary encoded values as strings. The editor checks, if the encoding
contains valid characters. The data type "hexBinary" can be edited by entering each 
binary octet as two hexadecimal digits. For a valid "base64" string a group of 6 bits is mapped into an
array of 64 printable characters.

#### Examples:
- **hexBinary**:    3f3c6d78206c657673726f693d6e3122302e20226e656f636964676e223d54552d4622383e3f.
- **base64Binary**: PD94bWwgdmVyc2lvbj0iMS4wIiBlbmNvZGluZz0iVVRGLTgiPz4NCg==.


### Version 5.4.0
#### Fixes
1. Fixed the position of the paste dialogue window at screen borders.
2. Fixed a problem concerning the expansion indicator in side views (Relations View and others), which could make expansion disabled.
3. Documents based on CAEX 3.0 require the application of the mirror concept for facet attributes and interfaces. This is now corrected.
4. Attribute Type references in Attributes are also visible and editable in the Header View.

#### Added Features
1. A new paste option allows copying of classes and all included sub classes.
2. Updated modelling options and other news, such as the availability of a new program version, 
which are displayed on the start page, are now informed in the editor main window. The start page can now also be displayed 
permanently using the new button in the tool bar.


### Version 5.3.3
#### Fixes

1. **B111 - Fixed:** Editor does not store the corresponding XML text in pretty-print anymore, when opened an older file (used tool: Altova XMLSpy).
fixed
2. **B121 - Fixed:** When I want to do a AttributeNameMapping, I am able to select the attribute from the RoleRequirement but not from the SUC.

3. **B123 - Fixed:** At the attribute object: Why is it not possible to use a line break the header attribute "description"?

4. **B127 - Fixed:** A role requirement is required to have at objects in the IH. But when I have a SUC with three SRC and I instantiate it, there is no dialogue in the AMLeditor that asked me to choose one role requirement out of those three SRC. Instead it instantiates on object with three SRC again.
Feature added to this version
5. **B129 - Fixed:** When I select the data type xs:time in an attribute, the editors asked me to insert date AND time - according to a predefined scheme (YYYY-MM-DD HH:MM:SS). But when I try to insert a time directly (HH:MM:SS) an error occurs.

6. **B130 - Fixed:** When I select the data type xs:date in an attribute, the editors asked me to insert date AND time - according to a predefined scheme (YYYY-MM-DD HH:MM:SS). But when I try to insert a time directly (YYYY-MM-DD) an error occurs.

### Version 5.3.2
#### Fixes
1. Merging container parts which contain external references has been fixed.
2. Absolute URIs to Http, https and Ftp in External references are supported.

### Version 5.3.1
#### Fixes
A bug in the import file dialogue has been fixed.

### Version 5.3.0

#### Added Features

The editor offers a new possibility to load pre-modelled documents from a web repository. Furthermore
it offers a news channel for the distribution of information about AutomationML and the available software
tools. These two channels are viewable on a new start page. The page can be made visible via the View menu.
From this page the availability of editor updates will be reported. Download and installation of updates can
be started also.

A document, explaining the configuration possibilities is available [here](https://wiki.automationml.org/testfiles/90%20Software/10%20AutomationMLEditor/Configuration/AutomationMLEditorConfiguration.docx). 

### Version 5.2.9

#### Added Features

1. The paste option "Create AML object" for RoleClasses now allows copying of attributes and interfaces to the object 
1. Document statistics are available in the AMLFile view
2. Switch between multiple root parts of an AutomationML container from the main tool bar

#### Fixes

1. PlugIns from local NUGET feeds were not found
2. Exception raised in editing unknown constraint types


### Version 5.2.8

#### Added Features

1. The InternalLinks window has a new option "Don't show any internal link". This option is set
as default when starting the editor. This prevents the window from being refreshed unintentionally, 
which could lead to runtime limitations with large models.

2. When a document is validated, the conformity of the CAEX schema is also checked.

3. When moving an external interface, attached InternalLinks are taken to the new position.

#### Fixes

1. The new connection of existing InternalLinks by means of graphical interaction was not possible or incorrect in certain cases.

2. The selection of a node in a very large model that was not within the visible range of the editor could cause a long load on the editor. 


### Version 5.2.7

#### Added Features

1. Editing of Attribute Units is supported according to BPR Units, V 1.0.0. Unit values shall be obtained from the
UNECE Recommendation N°20 “Codes for Units of Measure Used in International Trade” catalogue.
Actual included version is Revision 7 of the document, which is the last approved revision from the year 2010.
Document reference is CEFACT/ICG/2010/IC013. The document is installed in the new catalogue folder in
the application installation folder. Replacement or modifications are possible. This feature has to be enabled with a new option via the settings menu.

2. Ed.2 of AutomationML defines an ExternalDataReference with MIMEType Attribute type. Adding references to external documents automatically sets the MIMEType according
to the files ending in case the ending is registered in the Editors MIMEType table.

3. Assignments of RoleClasses to SystemUnitClasses didn't allow, to copy the Attributes and Interfaces to the Class as this is possible with InternalElements. 
This feature has been added so that it is now possible to copy the elements to the SystemUnitClass. Also a select all check box has been added and scrolling has been enabled.

4. Option to accept double click on tree view items to edit the items name has been added.

5. A new dialogue allows inspection of errors raised when a not schema conform AMLdocument is loaded.

### Version 5.2.6

#### Fixes
1. The Schema Validation result window contains line numbers for detected schema violations.
2. Handling of white-space in XML files could cause a schema violation. This could be fixed.
2. Fixed a problem with URL value editing in the attribute view, when the URL contains white-space.
3. Fixed some problems with the PLCOpen reference dialogue editor.
4. The group editor window will update the list of group members now.
5. The List of public available plug-ins in the plugIn manager contained not assignable plugIns. The list has been filtered to only show assignable plugIns.
6. Document validation showed errors after split and merge cycle. Behaviour has been fixed (for most cases, but needs further testing). 
7. Pretty print of saved XML doesn't work properly. A Newline for attributes has been added to make the XML better readable. A better solution will be prepared. 
8. Editing of inherited attributes is locked. To enable editing attributes shall be explicitly overwritten.
9. After splitting of SUC Libs, the remaining Instance in the IH were marked as Mirrors due to an error in the AMLEngine. This has been fixed.


### Version 5.2.4

#### Added Feature
The PlugIn manager supports local NUGET feeds as plugIn sources

#### Fixes
Fixed a problem visualizing InternalLinks in captured tree view images

### Version 5.2.2

#### Added Features

1. It is possible to open the folder, containing the currently edited document. The Open folder button is placed in the header, near the displayed file name of the document.
2. You can add the log file and the document file as an attachment to a problem report now.

#### Fixes

1. The Zoom Slider problem is fixed
2. The culture (language setting) is not changed any more by the editor. 
3. Bugfix in Method "Expand all Internal Links", nested interfaces are also expanded.  
3. Fixed bugs which were delivered with intermediate version 5.2.1

### Version 5.2.0

### Modifications 

The Attribute value editors for some XSD Data types have been adapted to their value ranges, 
restrictions and formats according to the W3C XML Schema Specification. The reported bugs 
concerning the editing capabilities for certain types like xs:duration are corrected. 
The used format for XML conversions is fixed but will be configurable in a future version.

### Version 5.1.3

#### Added Features

1. If the loading time for an AutomationML document exceeds 2 seconds, a busy indicator is displayed.
2. Loading of Documents is an asynchronous method now.

#### Changed

1. The PlugIn Manager has been redesigned. 
2. PlugIn management of the AutomationMLEditor has been changed. All PlugIns are now loaded from the Application Data directory.
2. Icons for AttributeType-, RoleClass-, InterfaceClass- and SystemUnitClass libraries and InterfaceClasses have been modified.

#### Modifications 

1. Creation of URIs for AutomationML container parts has been modified. An existing relative folder structure is preserved.
2. Informal descriptions for properties of AutomationML containers have been added or modified.
3. When saving an AutomationML document whose source is an AutomationML container, the export of associated parts is offered as an option.

#### Bug Fixes

1. The validation of paths in External Reference elements was incorrect if parts of an AutomationML container were associated with them. This bug in the validation service has been fixed.
2. Paths in External Reference elements are changed when the document in question is saved as part of a container. The path is modified to be identical to the URI of the added container part. 
4. Solved a DLL version conflict when plugIn DLLS are loaded, which were developed using different AMLEngine versions.
5. A memory overflow caused by successive loading of documents is fixed
6. It could happen that the paste options were not selectable when inserting objects. this error is fixed.
7. A display error related to the identification of overwritten objects has been fixed.


### Version 5.1.2

#### Changed

Editing double values in the attributes view always tries to transform the format to the XML accepted format, 
using the '.' as decimal separator regardless of the language version.

#### Added Feature

A specific PlugIn Manager was added to search for additional PlugIns and allow installation of specific versions of PlugIns.

### Version 5.1.1

#### Added Features

Additional pre installed PlugIns:
1. Convert AML2OPCUA
2. IOSBAML2OPCUA (WebService)
3. OPCUA Server Search

### Version 5.1

Official release version for public use. Consolidated version with bug fixes for all bugs, listed in the AutomationML Wiki tools page.

#### Bug Fixes
1. Fixed some bugs related to the display of object-relations in the relation view.
2. Implementing missing uniqueness requirements of sibling names for CAEX version 2.15
3. Fixed the DateTime format to include time information (RevisionDate and LastChange)
4. Removing InternalElments with InternalLink Relations raised an exception in CAEX 2.15 documents. This has been fixed.
5. Mirroring across InstanceHierarchies with Drag 'n Drop is possible now.

#### Added Features

1. Added option to perform a schema verification before loading an AutomationML document. (see Settings/other/Editor Preferences)
2. Added option to initially open Attribute details of selected objects with attributes. (see Settings/Initially expand collections...)

### Version 5.0.10

In the past, criticism was frequently voiced that the icons look blurry. This version contains visible improvements of this non-functional but important aspect. 

### Version 5.0.9

The main changes in this version are related to the handling of the mapping in AutomationML. The changes effect the editing of CAEX 2.15 documents as well as the editing of CAEX 3.0 documents.

#### Bug Fixes

1. Fixed a Bug with tabular Attribute Editor, which didn't switch to attributes of selected elements.
8. Fixed a bug that didn't allow to add AMLObjects in the AttributeEditor when no Attribute was selected.
3. Fixed a false behaviour in the Aml.Engine Schema transformer regarding Mapping Elements when MultipleRoles are used in CAEX 2.15 (also in the downgrade transformation).
4. Added a missing feature in the Aml.Engine Schema transformer regarding the transformation of InternalElements as part of SystemUnitClasses.
4. Fixed a false behaviour in the Aml.Engine Validation service regarding Name References as they occur in mappings.

#### Behaviour Fixes
1. AMLGroup objects should be allowed to have additional Attributes and ExternaInterfaces.
3. Paste on SRC Node is possible now.
4. Paste Attributes on RoleRequirements is possible now.
4. Mapping to Attributes can include nested and inherited Attributes, as well as Attributes of ExtneralInterface objects.
5. Mapping to ExternalInterfaces can include nested and inherited ExternalInterfaces.
6. AttributeDataType of ListAttribute shall be empty.
7. ReadOnly flag set to Unit, Value, DefaultValue and AttributeDataType of ListAttribute.
8. ReadOnly flag set to Name, DataType of Sub Attributes of FrameAttribute.
10. The same role can be added multiple times to an InternalElement or SystemUnitClass. The paste method has been modified to allow this.
10. Paste Attributes on AttributeNameMapping Nodes in the Tree view. The paste operation is automatically selected dependent on the attribute source.
10. Paste ExternalInterfaces on Interface (ID,Name) Mapping Nodes in the Tree view. The paste operation is automatically selected dependent on the ExternalInterface source.
10. Paste ExternalInterfaces on RoleRequirements is possible now.

#### Changed Features
1. Mapping elements have a changed representation in the tree view. 
2. "No values" of elements in the tree view are clearly marked with the "no value" string


### Version 5.0.8

#### Bug Fixes and added features
Visit the [Aml.Editor Tools page](https://wiki.automationml.org/wiki/index.php/AutomationML_Editor#Version_5.0.0_--_pre_release_version_--/) for a detailed list.
Bug-Reports, affected by this release are numbered from B108 to B119. Some minor Bugs, not listed on the web page, have been fixed too, like for instance the expansion of all InternalLinks.

#### Added feature

1. A new Import Method "... from AutomationML" has been added. The method searches the AutomationML Download Web pages for White paper-, AR- 
and BPR- download links and offers the contained AML files to be imported. If this feature is used the resulting document should be validated, because
not all referenced libraries are always included in the ZIP-Packages, offered on the AutomationML Download Web.

#### Changes

1. The selection mode for tree view items has been changed. A tree view item was recognized as selected, when the left mouse button was pressed on a tree view item. In the new version, the selection is recognized, when the mouse button is released on a tree view item. This new behaviour allows dragging a tree view item into other panes without updating a view caused by a selection. 
Usually, users should not suffer from this, but it cannot be completely ruled out. Any anomalies that may be associated with this should be reported.

### Version 5.0.6

#### Bug Fixes
Visit the [Aml.Editor Tools page](https://wiki.automationml.org/wiki/index.php/AutomationML_Editor#Version_5.0.0_--_pre_release_version_--/) for a detailed list.

#### Changes
1. Zooming the GUI only effects the Tree views and no other UI elements like Icons or Menus like before. The reason to change this were some remarks about the appearance of UI elements after zooming. 

#### Added methods/features
1. Paste action for AttributeType elements on ExternalInterface and RoleRequirement elements has been added.

1. Support to edit a RefURI Attribute has been extended. The specific editor for PLCopenXML assignments has been modified. A specific editor for COLLADA assignments has been prepared (currently, access to COLLADA elements is not supported but could be added in the future).
Incorrectly formatted FILE Uris are recognized and repaired, if possible. MIME types are recognized if they exist to specify the type of the assigned content.

2. Double Click a selected ExternalInterface node which is an ExternalData connector starts a new process showing the external content. This works for Files with a registered extension (local files and zipped container parts) and http URLs. 

3. Document validation checks File URIs in ExternalData connectors and provides a repair option, if possible.

4. A new dialogue to enter a concrete ZOOM factor has been added.

5. Saved layouts contain window size, window position and ZOOM factor. Restoring the layout will reset these properties to the stored values.


### Version 5.0.5

#### Bug Fixes
Visit the [Aml.Editor Tools page](https://wiki.automationml.org/wiki/index.php/AutomationML_Editor#Version_5.0.0_--_pre_release_version_--/) for a detailed list.

#### Added methods/features

- AutomationML Groups can contain MIRRORS and also other AutomationML Groups.

### Version 5.0.4

#### Bug Fixes

1. Paste dialogue for a RoleClass with inherited Attributes or ExternalInterfaces as a RoleReq. now shows dialogue to select inherited elements.
2. Added and fixed validator items for consistency check.
3. Display of role requirement nodes according to settings fixed.
4. Assignment of empty AttributeDataType to an Attribute is allowed. 
5. Paste a CAEXPath copied from an AttributeType on the RefAttributeType property of an Attribute now instantiates the Attribute. 
6. Improvement of performance when an Attribute view is opened for a very long list of attributes.

### Version 5.0.3

#### Bug Fixes

1. Expansion state of expandable properties in Attribute view or Header view will be saved and reused, when selection returns to the same element.
2. Expansion and collapsing of expandable properties could led to unwanted expansion of other properties in the view.
3. Collection in the attribute view like Constraints were not expanded when items have been added.
4. Browsing a tree view with cursor keys could have a bad performance when property views are visible. 
5. Some problems with internal link drawings have been fixed.
6. The Reset PlugIn menu has been cleared of unnecessary methods.

#### Added Methods

1. Context Menu for selected tree view items contains more options, like cut and delete.
2. A new method has been added to the context menu to navigate to related ExternalInterface
objects when an ExternalInterface with InternalLink relations is selected (reported as B76 in [Aml.Editor Tools page](https://wiki.automationml.org/wiki/index.php/AutomationML_Editor#Version_5.0.0_--_pre_release_version_--/))

#### Changes

1. If **PlugIns** are provided to the AutomationML editor, each PlugIn should define its own subdirectory in the editors PlugIn sub folder. The PlugIn folder for a specific PlugIn shall not be equal to the name of the PlugIn DLL itself. If incompatible DLL references exist in a PlugIn, an error message is shown at application start-up and the PlugIn is rejected. Compatible PlugIns are always loaded.

### Version 5.0

 #### Release notes


1.	Added support for editing and converting AutomationML documents based on **CAEX 3.0**.

	The Editor's features are always configured according to the CAEX version of the currently loaded document.
	 If the CAEX version is changed to a higher or lower version, the document will be automatically transformed
	 and the Editor will change its configuration to enable editing of the version related elements. Be careful
	using the downgrade transformation as document content can be deleted. For CAEX 3.0 based documents a new **AttributeType library**
	window is shown. The CAEX version switch is placed at the top right of the main window.

	![Caex3](img/caex3.png)


2.	**Undo/Redo** support.

	All Confirmation dialogues have been removed because any action can be undone. Complex operations are grouped in transactions.
	
3.	Added support for expanding InternalLinks to graphic representations.

	Displaying all InternalLinks as graphic representations has been replaced with individual link expansion buttons. 
Because the tree view loading uses virtualisation,	InternalLink partners may be outside of the visual range. If such links
exists an information icon is shown which allows navigating to the InternalLink partner. 

4.	Added view for displaying class-class relations and instance-instance relations.

	The old InternalLinks content pane has been replaced by the new **Relations pane**. This window contains the Instance-Instance relations,
which are Mirror- Master- and InternalLink objects as well as Class-Class relations which represent inheritance relations.

5.	Added support for editing and building **AMLContainers**.

	The AMLDocument content pane contains a new category for editing AutomationML Containers. The container parts, which are AutomationML documents, can be selected for
editing, as it is shown in the container edit dialogue, below.

	![Container](img/Container.png)

	All root documents and AutomationML libraries, which are listed in the container can be loaded for editing by simply clicking the edit button, close to the URI. The currently opened
and edited document is marked with a little green rectangle. You can always see, if you are editing a document, which belongs to an AutomationML container by looking at the top window border
and the little container symbol at the left of the file name.

	![Container Symbol](img/containerSymbol.png)

	If a container part is currently edited, saving the document will also save the container as a whole. If any AutomationML document is added as a new container part, all external sources which
are referenced from the AutomationML document can be selected to be loaded to the container as well.

6.	Added support for creating and editing specific **AutomationML objects**.

	The *blue AutomationML button* has been replaced by specific AutomationML object creation and editing methods. The new paste dialogue shows an additional option for
the creation of AutomationML objects. Specific editing dialogues are added for AMLFacet, AMLGroup and ListAttributes.

7.	Added buttons for node navigation.

	The selection history in tree views is saved and it is possible to navigate backward and forward to previous selected nodes.

8.	Changed paste dialogue.

	The drag and drop operations have been redesigned. Drop is only possible, if a real drop option is available. The drop dialogue has been
modified. The dialogue displays all available paste actions and some additional editing options if they exist for the selected action.

	If an attribute type should be assigned to an attribute, it is possible to drag the attribute type node from the library tree dropping it on the "Type reference" property of the attribute. The attribute view pane has to be fixed (non reactive) for this.

9.	Modified properties view.

	The content panes, which are used for Attribute editing, display of header attributes, relations, validation information and document
 related properties have been redesigned and unified. 
  * Editing options for any property are visualized by a little filled rectangle at the right 
edge of the property field. As an example this feature is applied for editing values of *refURI Attributes* to enable the selection of the referenced external source.

	![Uri](img/uri.png)

  * If a pane should not automatically change its content due to a selection of a tree node, 
	the pane can be made non-reactive (left most icon shown below). The non-reactive mode should be enabled, 
	if you want to drag an AttributeType node from the AtrributeTypeLib tree to an AttributeTree, shown in the Attributes pane. In the reactive-mode, the AttributeTree pane would show the AttributeType-AttributeTree.
	Disabling of the reactive mode may also be appropriate, if you want to navigate to a tree node by selecting an element, shown in a Properties pane. 
	
	![Non Reactive](img/nonReactive.png)

10. The split method has been extended.

	The split method is also available in the context menu of objects, which are possible split targets. The split method can be executed for the selected object without setting a split point on this object.

	If the split method is applied in a document, which is part of an AutomationML container the split part will be added as a new container part, defined with a Library Relation.

11. The merge method has been extended.

	The merge method can be directly applied on an External Reference, shown in the AMLDocument view by clicking on the properties button at the "Path"-property.

	If the merge method is applied in a document, which is part of an AutomationML container, the corresponding container parts, which contain the data streams for the externals, will be removed from the container.

13. Added display mode for deleted objects in all tree views. 

	All elements with a ChangeMode of *deleted* will show a deleted icon in the tree view representation. The "delete" option has been added to the "override" methods for
inherited attributes.

14. Additional display option "Always expand InternalLink for updates" will expand the InternalLink to show a connecting line, always when changes are made on the InternalLink.

14. Additional display option "Preserve White-space" allows formatting of the saved XML text with or without white-space chars.

14. Additional display option "Show Descriptions" will show a description area in a properties view containing explanations to the selected property.

15. Dragging a tree node to a closed inactive tab will activate the tab.

11. Introduction of additional short cuts for new methods.

12. Current loaded file name is shown in the top window border.

13. The PLCopen viewing features could not be migrated to this version, because of a version and license conflict. PLCopen viewing is outsourced into a PlugIn, which contains all formerly provided views. When
the PlugIn is activated each selection of an ExternalInterface with a PLCopen URI updates the views. 

13. Integrated Feedback function for problem reports or feature requests.    

	![Feedback](img/feedback.png)


#### removed features and open issues 


2. Some presentation options -available in version 4.x- have been removed.

2. The automatic application and plugIn update feature is not included in this version. This feature will be again included in a later version.

3. The interlocking wizard is not included in this version. This feature will be added to an upcoming version. 

#### requirements

1. AutomationML Editor v5.x has a minimal requirement of **.NET framework version 4.7**.

2. AutomationML Editor v5.x is based on the new [Aml.Engine](https://www.nuget.org/packages/Aml.Engine/) (AMLEngine2.1).
	
	AutomationML Editor plugIns can only be loaded into this version of the editor, if they are based on the same engine version. The plugIn contract .NET DLL has
	to be exchanged, too.
